if (command$="") then
  print "------------------------------------------------------------------------"
  print "Cmdline: Flash51 myfile.hex to com1 at 57600 baud for P89C51RD+ at 22Mhz"
  print "  This utility downloads a .HEX file (for example 'myfile.hex')  using"
  print "  the PC COM port to a  Philips             8051 FLASH microcontroller" rem  print "  the PC COM port to a  Philips  or  Temic  8051 FLASH microcontroller"
  print "  if you do not specify the  com port, baud rate, chip type or crystal"
  print "  frequency,  then it will default to the values shown in the example."
  print "  If you set incorrect parameters the utility will, surprisingly, fail."
  print "  For sanity, run this utility from a batch file, don't retype the line"
  print "  Utility version 1.02,  www.airborn.com.au/flash51.html,  1  Jan  2001"
  print "Cmdline: Flash51 myfile.hex to com1 at 57600 baud for P89C51RD+ at 22Mhz"
  print "------------------------------------------------------------------------":end
end if
incmd$=remove$(command$,",")
ChipNm=2                                                rem Number of chips
Retries=10                                              rem Coms retry value
Dim Chip$(ChipNm,2):Dim chip(ChipNm,10)
Dim b%(132)                                             rem Intel Hex line buf
Dim Block%(256)                                         rem Memory blocks used
rem -----full part number--search part number--eraseBlock--MemSize---
Chip$(0,0)="P89C51RD+":Chip$(0,1)="89C51RD+":Chip(0,1)=1:Chip(0,2)=65536
Chip$(1,0)="T89C51RD2":Chip$(1,1)="T89C51":Chip(1,1)=1:Chip(1,2)=65536
comport=1:comport$="com1":baud=9600:UseChip=0:clk=22    rem Set defaults
filename$ = Extract$(incmd$," ")
if instr(filename$,".")=0 then filename$=filename$+".hex":if filename$="" then end
filename$=dir$(filename$):if filename$="" then print "Can't find .HEX file":end
if instr(lcase$(incmd$),"com4") <> 0 then comport=4:comport$="com4"
if instr(lcase$(incmd$),"com3") <> 0 then comport=3:comport$="com3"
if instr(lcase$(incmd$),"com2") <> 0 then comport=2:comport$="com2"
if instr(lcase$(incmd$),"com1") <> 0 then comport=1:comport$="com1"
for i=0 to ChipNm-1
  if instr(ucase$(incmd$),ucase$(Chip$(i,1))) <> 0 then UseChip=i
next i

Secure=0
if instr(lcase$(incmd$),"secur") then Secure=1
if instr(lcase$(incmd$),"lock") then Secure=1

temp1$ = rtrim$(Extract$(lcase$(incmd$),"baud"))
Gosub Getnumeric
if k>1 then baud=k
temp1$ = rtrim$(Extract$(lcase$(incmd$),"mhz"))
Gosub Getnumeric
if k>1 then clk=k

Print:Print "Flash51 ";filename$;" to ";comport$;" at";baud;"baud";
Print    " for ";Chip$(UseChip,0);" at";clk;"Mhz";
If Secure=1 then print " with inhibit Flash Verify security"
Print:Print "Opening file...";
open filename$ for input as #1
temp1$ = comport$+":"+str$(baud)+",N,8,1"
Print "Opening ";temp1$;"...";
On error goto ErrHandler
open temp1$ as #2
On error goto 0

Print "Integrity checking .HEX file..."
for i=0 to 256:Block%(i)=0:next i:lines=0               rem Clear Mem Map

IHxLineChk:
    input #1, a$:lines=lines+1:a$=rtrim$(ltrim$(a$))    rem Tolerate spaces
    if a$="" goto IHxLineCkX                            rem Tolerate CR's
    if mid$(a$,1,1)<>":" then
      print:print "Not correct .HEX file - couldn't see ':'"
      close:end
    end if
    Cks=256
    For J%=2 to len(a$) step 2
      C%=asc(mid$(a$,J%,1))-48
      If C%>9 then
        C%=C%-7
      end if
      D%=asc(mid$(a$,J%+1,1))-48
      If D%>9 then
        D%=D%-7
      end if
      B%(J%/2)=(C%*16)+D%
      Cks=Cks-B%(J%/2):If Cks<0 then Cks=Cks+256
      next J%
    address%=(B%(2)*256)+B%(3)
    if Cks<>0 then
      print:print "Bad .HEX file checksum on line ";lines
      close:end
    end if
    if B%(1) <> (len(a$)-11)/2 then                     rem Chk Len of pkt
      print:print "Bad .HEX file length on line ";lines
      close:end
    end if
    if B%(4)=0 then
      if B%(1) > 0 then                                 rem Chk if any data
        Block%(B%(2))=1                                 rem Mark data in blk
        Block%( int( ((address%+B%(1))-1) /256) )=1     rem Chk last line loc
      end if
    end if
    if (address%+B%(1)-1) > (Chip(UseChip,2)-1) then    rem Chk if enough mem
      print:print ".HEX file contains data above chip memory capacity "
      print "on line ";lines:close:end
    end if
IHxLineCkX:
    if not eof(1) goto IHxLineChk
close #1:open filename$ for input as #1                 rem Restart file input
Gosub GetResponse                                       rem Clear input buf

SendPing:
Print "Sending autobaud ping...";:print #2,"U";         rem Send signon ping
Gosub WaitResponse
if response$<>"U" then print "Bad response..":Gosub retry:Goto SendPing

SendOsc:
temp1$ = ":01000002"+right$("0"+hex$(clk),2)+right$("0"+hex$(253-clk),2)
Print "Sending Crystal freq...";:print #2,temp1$  rem Oscillator packet
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto SendOsc

Goto EraseB0   Rem FullErase seems to be REALLY disabled on P89C51RD+IA
FullErase:
Print "Full Chip Erase...":Print #2, ":0100000307F5"
Gosub WaitResponse
if response$="." then goto EraseB0: rem BlankCheck  <--do indiv erase anyway
Print "Retrying Full Chip Erase...":Print #2, ":0100000307F5"
Gosub WaitResponse
if response$<>"." then
  print "Bad response,giving up..":Goto EraseB0
else
  goto EraseB0: rem BlankCheck  <--do indiv erase anyway
end if

EraseB0:
j%=0:for i=0 to 31:j%=j%+Block%(i):next i               rem Chk if Blk0 Used
if j%=0 then goto EraseB1
Print "Erasing Block 0...":Print #2, ":020000030100FA"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto EraseB0

EraseB1:
j%=0:for i=32 to 63:j%=j%+Block%(i):next i              rem Chk if Blk1 Used
if j%=0 then goto EraseB2
Print "Erasing Block 1...":Print #2, ":020000030120DA"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto EraseB1

EraseB2:
j%=0:for i=64 to 127:j%=j%+Block%(i):next i             rem Chk if Blk2 Used
if j%=0 then goto EraseB3
Print "Erasing Block 2...":Print #2, ":020000030140BA"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto EraseB2

EraseB3:
j%=0:for i=128 to 191:j%=j%+Block%(i):next i            rem Chk if Blk3 Used
if j%=0 then goto EraseB4
Print "Erasing Block 3...":Print #2, ":0200000301807A"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto EraseB3

EraseB4:
j%=0:for i=192 to 255:j%=j%+Block%(i):next i            rem Chk if Blk4 Used
if j%=0 then goto BlankCheck
Print "Erasing Block 4...":Print #2, ":0200000301C03A"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto EraseB4

BlankCheck:
temp2$=":050000040000"+right$("000" + hex$((Chip(UseChip,2)-1)),4)
Cks=248-int((Chip(UseChip,2)/256)-1):If Cks<0 then Cks=Cks+256
temp2$=temp2$+"00"+right$("0"+hex$(Cks),2)
rem We have removed blank check, as chip dumps data, in manner of a Read.
rem Print "Blank Check...":Print #2, temp2$
rem Gosub WaitResponse
rem if response$<>"." then print "Bad response..":Gosub retry:Goto BlankCheck

Print "Programming...";:lines=0
IHxLineGet:
    input #1, a$:lines=lines+1:a$=rtrim$(ltrim$(a$))    rem Tolerate spaces
    if a$="" goto IHxLineGetX                           rem Tolerate CR's
  Lineretry:
    print #2, a$                                        rem Send to 8051
    Gosub WaitResponse
    if response$="R" then
      Print "Byte would not program on .HEX file line ";lines
      Gosub retry:Goto Lineretry
    end if
    if response$<>"." then print "Bad response..":Gosub retry:Goto Lineretry
    Print ".";
IHxLineGetX:
    if not eof(1) goto IHxLineGet
close #1

ReadBV:
Print:Print "Reading Boot...";:Print #2, ":020000050702F0"
Gosub Get18chars
if instr(success$,"FC.")=0 then Goto EraseBV

ReadStat:
Print "Reading Status...";:Print #2, ":020000050701F1"
Gosub Get18Chars
if instr(success$,"00.")<>0 then Goto BootDone

EraseBV:
Print:Print "Erasing Boot/Status...";:Print #2, ":020000030400F7"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto EraseBV

ProgBV:
Print "Program Boot...";:Print #2, ":030000030601FCF7"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto ProgBV

ProgStat:
Print "Program Status...":Print #2, ":03000003060000F4"
Gosub WaitResponse
if response$<>"." then print "Bad response..":Gosub retry:Goto ProgStat

BootDone:
ProgLock2:
If Secure=1 then
  Print "Secure LockBit2...":Print #2, ":020000030501F5"
  Gosub WaitResponse
  if response$<>"." then print "Bad response..":Gosub retry:Goto ProgLock2
end if

AllDone:
Close:Print "Download successfully completed"

end
rem --Subroutines------------------
Getnumeric:
temp2$=""
for i=len(temp1$) to 1 step -1
  j=ascii(mid$(temp1$,i,1)):k=0
  if ((j>47) * (j<58)) then k=1:temp2$=chr$(j)+temp2$
  if j=asc(".") then k=1:temp2$=chr$(j)+temp2$
  if k=0 then i=1
next i
k=val(temp2$)
return

WaitResponse:
Gosub GetResponse:if tally(response$, any "UXR.") then WaitResponseX
for i=1 to (18*3)                                       rem Delay for 2-3 sec
  Delay(0.08)
Gosub GetResponse:if tally(response$, any "UXR.") then WaitResponseX
next i
WaitResponseX:
return

Get18Chars:
if eof(2) then Delay(0.08)
if eof(2) then Delay(0.16)				rem wait for reply
Delay(0.08)						rem allow CPU process
Delay(250/baud)						rem allow for Tx time
On error goto ErrHandler
  success$=input$(18,#2)
On error goto 0
Gosub GetResponse					rem Flush buffer
return

GetResponse:
response$=""
On error goto ErrHandler
  while not eof(2)
    thisinput$=input$(1,#2)
    if ascii(thisinput$)=10 then thisinput$=""
    if ascii(thisinput$)=13 then thisinput$=""
    if thisinput$<>"" then response$=thisinput$
  wend
On error goto 0
return

ErrHandler:
  Print Chr$(95);
  If err=57 then resume     				rem Tolerate I/O err
  If err=24 then
    print "There was a timeout on the serial port -"
    print "  check that the target is properly connected,"
    print "  (especially check that the handshake lines are at their"
    print "   proper levels or are looped back CTS--RTS, DTR--DSR--DCD)":end
  end if
  On error goto 0
  end

retry:
retries=retries-1
if retries>0 then return
close
Print:Print "Coms retry limit exceeded, exiting"
end
